"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var util = __importStar(require("../util"));
var isArray = function (it) { return Array.isArray(it); };
var isObject = function (it) { return typeof it === "object" && !isArray(it); };
var fixObject = function (obj) {
    if (!isObject(obj))
        return obj;
    var keys = Object.keys(obj);
    if (keys.includes("supportedObjPath"))
        return __assign({ access: "OBJ_READ_ONLY" }, fillZeroParams(obj));
    if (keys.includes("paramName"))
        return __assign({ access: "PARAM_READ_ONLY", valueType: "PARAM_UNKNOWN", valueChange: "VALUE_CHANGE_UNKNOWN" }, fillZeroParams(obj));
    if (keys.includes("commandName"))
        return __assign({ commandType: "CMD_UNKNOWN" }, fillZeroParams(obj));
    return fillZeroParams(obj);
};
var fillZeroParams = function (obj) {
    if (!isObject(obj))
        return obj;
    return Object.entries(obj).reduce(function (acc, _a) {
        var _b;
        var key = _a[0], value = _a[1];
        return (__assign(__assign({}, acc), (_b = {}, _b[key] = isArray(value) ? value.map(fixObject) : fixObject(value), _b)));
    }, {});
};
var decode = function (msg) {
    var results = util.search(msg, "reqObjResults");
    return [results.map(fillZeroParams)];
};
var encode = function (_a) {
    var paths = _a.paths, _b = _a.opts, opts = _b === void 0 ? {} : _b;
    return ({
        lookup: "Msg",
        header: {
            msgId: util.uniq("GET_SUPPORTED_DM@"),
            msgType: "GET_SUPPORTED_DM",
            lookup: "Header",
        },
        body: {
            lookup: "Body",
            request: {
                lookup: "Request",
                getSupportedDm: {
                    objPaths: Array.isArray(paths) ? paths : [paths],
                    firstLevelOnly: opts.firstLevelOnly || false,
                    returnCommands: opts.returnCommands || false,
                    returnEvents: opts.returnEvents || false,
                    returnParams: opts.returnParams || false,
                },
            },
        },
    });
};
exports.default = {
    decode: decode,
    encode: encode,
};
